#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;
        
#define MX 200001

int p[MX];
long long h[MX], ln = 0;
vector <int> g[MX];

void dfs(int v)
{
	long long mx1 = -1, mx2 = -1;
	for (auto u : g[v])
	{
		dfs(u);
		if (h[u] >= mx1) 
		{
			mx2 = mx1;
			mx1 = h[u];
		}
		else
		{
			if (h[u] > mx2) mx2 = h[u];
		}
	}
	h[v] = mx1+1;
	ln = max(ln, mx1+mx2+2);	
}

                                    
int main ()
{
	int n, m;
	cin >> n >> m;
	
	p[0] = 0;
	for (int i = 1; i < n; i++) 
	{
		cin >> p[i];
		p[i]--;
		g[p[i]].push_back(i);
	}
	
	dfs(0);
	long long ans = ln + 2*(m-1)*(h[0]+1);
	//cout << ln << " " << h[0] << "\n";
	cout << ans+1 << "\n";
	return 0;
}

